% Bredemeier, Juessen, and Winkler, 2022. 
% This file simulates the Pandemic scenario
  
var gdp1 gdp2 k1 k2 hp hb hw hp1 hb1 hp2 hb2 hw1 hw2 y y1 y2 fp1 fk1 fb1 fw1 fp2 fk2 fb2 fw2 r i1 i2 g g1 g2 c c1 c2 wp wb ww wp1 wp2 wb1 wb2 ww1 ww2 aa1 aa2 b s u1 u2 au1 au2 mc1 mc2 pi pi1 pi2 p1 p2 pg 
uc lambdaS VV SS un_b un_p un_w rk1 rk2 q1 q2 kbbundle1 kbbundle2 hpbundle1 hpbundle2 w_agg h_agg h1 h2 rr u gdp tau tauk wedp wedb wedw wed1 wed2 p1wed p2wed np1 np2 np nb1 nb2 nb nw1 nw2 nw n1 n2 n_agg def zetag lipp liww libb lsp lsw lsb;
varexo eps_g eps_tau eps_cov1 eps_cov2 eps_covp eps_covb eps_covw;

parameters alpha1 alpha2 gamma1 gamma2 chi1 chi2 phi iota kappa_b1 kappa_p1 kappa_b2 kappa_p2 kappa_w1 kappa_w2 rho_g rho_a rho_s epsilon1 epsilon2 psi1 psi2 delta delta_pi delta_y delta_r delta_g kappa_i1 kappa_i2 xi zeta nu nug gamma_sb eta 
omega_n omega_p omega_w beta sigma theta delta1 delta2 tau_bar tauk_bar hp_int hb_int hw_int lambda kappa_diff kappa_idiff k1_bar k2_bar hp_bar hb_bar hw_bar hp1_bar hb1_bar hw1_bar hp2_bar hb2_bar hw2_bar y_bar y1_bar y2_bar fp1_bar fk1_bar fb1_bar fw1_bar fp2_bar fk2_bar fb2_bar fw2_bar r_bar 
i_bar i1_bar i2_bar def_bar g_bar g1_bar g2_bar c_bar c1_bar c2_bar wp_bar wb_bar ww_bar wp1_bar wb1_bar ww1_bar wp2_bar wb2_bar ww2_bar aa1_bar aa2_bar b_bar s_bar u1_bar u2_bar au1_bar au2_bar mc1_bar mc2_bar pi_bar p1_bar p2_bar pg_bar uc_bar lambdaS_bar VV_bar SS_bar un_b_bar un_p_bar un_w_bar
gdp1_bar gdp2_bar rk1_bar rk2_bar q1_bar q2_bar kbbundle1_bar kbbundle2_bar hpbundle1_bar hpbundle2_bar w_agg_bar h_agg_bar h1_bar h2_bar u_bar gdp_bar rho_tau rho_tauk sigma_tau sigma_tauk zetag_bar sigma_g sigma_zeta rho_zeta
lip_bar liw_bar lib_bar rho_cov rho_cov1 rho_cov2 rho_covp rho_covw rho_covb lsb_bar lsp_bar lsw_bar;

sigma_tau=1;
sigma_tauk=1;
sigma_tax=[sigma_tau sigma_tauk];
sigma_matG=[1 -0.0685]; % sigma_matG(1): gov spending shock; sigma_matG(2): zetag shock
rho_cov=0.741;
rho_cov1=rho_cov;
rho_cov2=rho_cov;
rho_covw=rho_cov;
rho_covb=rho_cov;
rho_covp=rho_cov;
sigma_g=sigma_matG(1);
sigma_zeta=sigma_matG(2);
sigma_tau=sigma_tax(1);
sigma_tauk=sigma_tax(2);
iota=1.0001;
phi=2.7;
delta_g=-0.364;                         
kappa_diff=1.8;
hb_int=0.251813422; 
hp_int=0.836349901;
hw_int=0.522369029; 
kappa = 1.85;                          
kappa_b1 = 1/kappa_diff*kappa;         
kappa_p1 = 1/kappa_diff*kappa;
kappa_w1 = 1/kappa_diff*kappa;
kappa_b2 = kappa_diff*kappa;         
kappa_p2 = kappa_diff*kappa;
kappa_w2 = kappa_diff*kappa;
kappa_idiff=1;
kappa_i1 = kappa_idiff*9;
kappa_i2 = 1/kappa_idiff*9;
eta = 1/0.72;                         
epsilon1=6;                            
epsilon2=6;
calvo=2/3;
rho_g = 0.9;
rho_a = 0.9;
rho_s = 0.9;
rho_tau = 0.9;
rho_tauk = 0.9;
rho_zeta = 0.9;
delta = 0.022;
u_bar = 1;
gamma_sb=0.04;
u_elast=3;                             
delta_pi=1.5;
delta_y=0.5/4;
delta_r=0;
sigma=1;
labor_share=0.67;
ww_ratio = 1.5882;  
w_ratio = 0.7723;                
tau_bar=0.28;
tauk_bar=0.36; 
nu= 1.0001;
nug= 1.0001; 
lambda=1;      
beta=0.9927;                              
xi=0.0001;
y_bar = 1;
y1_bar =0.5*y_bar;    
y2_bar=y_bar-y1_bar;  
hb_bar=1;
hp_bar=1.320201126*hb_bar;     
hw_bar=1.877705336*hb_bar;    
hb1_bar=hb_int*hb_bar;
hb2_bar=hb_bar-hb1_bar;
hp1_bar=hp_int*hp_bar;
hp2_bar=hp_bar-hp1_bar;
hw1_bar=hw_int*hw_bar;
hw2_bar=hw_bar-hw1_bar;
h1_bar=hp1_bar+hb1_bar+hw1_bar;
h2_bar=hp2_bar+hb2_bar+hw2_bar;
zetag_bar=0.55;
p1_bar=1;
p2_bar=1;
pi1_bar=1;
pi2_bar=1;
pi_bar=1;
pg_bar=1;
q1_bar=1;
q2_bar=1;
u1_bar=1;
u2_bar=1;
au1_bar=0;
au2_bar=0;
mc1_bar=(epsilon1-1)/epsilon1;
mc2_bar=(epsilon2-1)/epsilon2;
g_bar=0.1961*y_bar; 
g1_bar=zetag_bar*g_bar;
g2_bar=(1-zetag_bar)*g_bar;
b_bar=0.63*4*y_bar;
wb_bar=labor_share*y_bar/(hb_bar+hp_bar*w_ratio+hw_bar*ww_ratio);
wb1_bar=wb_bar;
wb2_bar=wb_bar;
wp_bar=w_ratio*wb_bar;
wp1_bar=wp_bar;
wp2_bar=wp_bar;
ww_bar=ww_ratio*wb_bar;
ww1_bar=ww_bar;
ww2_bar=ww_bar;
labor_share1=wb_bar*(hb1_bar+hp1_bar*w_ratio+hw1_bar*ww_ratio)/y1_bar;
labor_share2=wb_bar*(hb2_bar+hp2_bar*w_ratio+hw2_bar*ww_ratio)/y2_bar;
k1_share=1-(1-mc1_bar)-labor_share1;
k2_share=1-(1-mc2_bar)-labor_share2;
rk1_bar=(1/beta+delta-1)/(1-tauk_bar);
rk2_bar=rk1_bar;
r_bar=1/beta;
k1_bar=k1_share*y1_bar/rk1_bar;
k2_bar=k2_share*y2_bar/rk2_bar;
k_bar=k1_bar+k2_bar;
i1_bar=delta*k1_bar;
i2_bar=delta*k2_bar;
c1_bar=y1_bar-g1_bar-i1_bar;
c2_bar=y2_bar-g2_bar-i2_bar;
zeta=c1_bar/(c1_bar+c2_bar);
c_bar=c1_bar+c2_bar;
i_bar=i1_bar+i2_bar;
fk1_bar = rk1_bar/mc1_bar;
fk2_bar = rk2_bar/mc2_bar;
fb1_bar=wb_bar/mc1_bar;
fb2_bar=wb_bar/mc2_bar;
fp1_bar=wp_bar/mc1_bar;
fp2_bar=wp_bar/mc2_bar;
fw1_bar=ww_bar/mc1_bar;
fw2_bar=ww_bar/mc2_bar;
aa1_bar=1;
aa2_bar=1;
chi1=1-fw1_bar*hw1_bar/y1_bar;
chi2=1-fw2_bar*hw2_bar/y2_bar;
alpha1=1-fp1_bar*hp1_bar/(y1_bar*chi1);
alpha2=1-fp2_bar*hp2_bar/(y2_bar*chi2);
gamma1=fk1_bar*k1_bar/(y1_bar*alpha1*chi1);
gamma2=fk2_bar*k2_bar/(y2_bar*alpha2*chi2);
kbbundle1_bar=1;
kbbundle2_bar=1;
hpbundle1_bar=1;
hpbundle2_bar=1;
s_bar=b_bar/r_bar+tau_bar*wb_bar*hb_bar+tau_bar*wp_bar*hp_bar+tau_bar*ww_bar*hw_bar+tauk_bar*rk1_bar*(u1_bar*k1_bar)+tauk_bar*rk2_bar*(u2_bar*k2_bar)-b_bar/pi_bar-pg_bar*g_bar;
h_agg_bar=hb_bar+hp_bar+hw_bar;
delta1=rk1_bar*(1-tauk_bar);
delta2=1/u_elast*delta1; 
calvo_mc=(1-calvo)*(1-beta*calvo)/calvo;
psi1=(epsilon1-1)/calvo_mc;
psi2=psi1;
%JR preferences;
SS_bar=c_bar;
xin=wb_bar*(1-tau_bar)/(hb_bar^eta*c_bar);
xip=wp_bar*(1-tau_bar)/(hp_bar^eta*c_bar);
xiw=ww_bar*(1-tau_bar)/(hw_bar^eta*c_bar);
omega_n=xin/(1+xi/(1-beta*(1-xi))*(xin/(1+eta)*hb_bar^(1+eta)+xip/(1+eta)*hp_bar^(1+eta)+xiw/(1+eta)*hw_bar^(1+eta)));
omega_p=omega_n*xip/xin;
omega_w=omega_n*xiw/xin;
VV_bar=(c_bar-(omega_n/(1+eta)*hb_bar^(1+eta)+omega_p/(1+eta)*hp_bar^(1+eta)+omega_w/(1+eta)*hw_bar^(1+eta))*SS_bar)^(-sigma);
lambdaS_bar=-VV_bar*(omega_n/(1+eta)*hb_bar^(1+eta)+omega_p/(1+eta)*hp_bar^(1+eta)+omega_w/(1+eta)*hw_bar^(1+eta))/(1-beta*(1-xi));
uc_bar=VV_bar+xi*lambdaS_bar;
un_b_bar=omega_n*hb_bar^eta*VV_bar*SS_bar;
un_p_bar=omega_p*hp_bar^eta*VV_bar*SS_bar;
un_w_bar=omega_w*hw_bar^eta*VV_bar*SS_bar;
w_agg_bar=(wp_bar*hp_bar+wb_bar*hb_bar+ww_bar*hw_bar)/h_agg_bar;
u_bar=(k1_bar*u1_bar+k2_bar*u2_bar)/(k1_bar+k2_bar);
gdp_bar=c_bar+pg_bar*g_bar+p1_bar*i1_bar+p2_bar*i2_bar;
gdp1_bar=c1_bar+i1_bar+g1_bar;
gdp2_bar=c2_bar+i2_bar+g2_bar;
def_bar=b_bar*(1/r_bar-1/pi_bar);
lip_bar=hp_bar*wp_bar*(1-tau_bar);
liw_bar=hw_bar*ww_bar*(1-tau_bar);
lib_bar=hb_bar*wb_bar*(1-tau_bar);
lsp_bar=lip_bar/(lip_bar+lib_bar+liw_bar);
lsb_bar=lib_bar/(lip_bar+lib_bar+liw_bar);
lsw_bar=liw_bar/(lip_bar+lib_bar+liw_bar);
theta=0.07;
%theta=(1-hb_bar/h_agg_bar*phi-hw_bar/h_agg_bar*iota)*h_agg_bar/hp_bar;

model;
    //
    //Household
    //
    VV=(c-(omega_n/(1+eta)*hb^(1+eta)+omega_p/(1+eta)*hp^(1+eta)+omega_w/(1+eta)*hw^(1+eta))*SS)^(-sigma);
    SS=c^xi*SS(-1)^(1-xi);
    uc=VV+xi*lambdaS*SS/c;
    lambdaS=-VV*(omega_n/(1+eta)*hb^(1+eta)+omega_p/(1+eta)*hp^(1+eta)+omega_w/(1+eta)*hw^(1+eta))+beta*(1-xi)*lambdaS(+1)*SS(+1)/SS;
    un_b=omega_n*hb^eta*VV*SS;
    un_p=omega_p*hp^eta*VV*SS;
    un_w=omega_w*hw^eta*VV*SS;
    wb*(1-tau)=un_b/uc;
    wp*(1-tau)=un_p/uc;
    ww*(1-tau)=un_w/uc;
    uc=beta*uc(+1)*r/pi(+1);
    c1=zeta*((1+wed1)*p1)^(-nu)*c;
    c2=(1-zeta)*((1+wed2)*p2)^(-nu)*c;
    1=zeta*((1+wed1)*p1)^(1-nu)+(1-zeta)*((1+wed2)*p2)^(1-nu);
    hp1=hp_int*((1-wedp)*wp1/wp)^lambda*hp;
    hp2=(1-hp_int)*((1-wedp)*wp2/wp)^lambda*hp;
    hb1=hb_int*((1-wedb)*wb1/wb)^lambda*hb;
    hb2=(1-hb_int)*((1-wedb)*wb2/wb)^lambda*hb;
    hw1=hw_int*((1-wedw)*ww1/ww)^lambda*hw;
    hw2=(1-hw_int)*((1-wedw)*ww2/ww)^lambda*hw;
    wp^(1+lambda)=hp_int*((1-wedp)*wp1)^(1+lambda)+(1-hp_int)*((1-wedp)*wp2)^(1+lambda);
    wb^(1+lambda)=hb_int*((1-wedb)*wb1)^(1+lambda)+(1-hb_int)*((1-wedb)*wb2)^(1+lambda);
    ww^(1+lambda)=hw_int*((1-wedw)*ww1)^(1+lambda)+(1-hw_int)*((1-wedw)*ww2)^(1+lambda);
    //
    //Fiscal and monetary policy
    //
    b/r+tau*wb*hb+tau*wp*hp+tau*ww*hw+tauk*rk1*(u1*k1(-1))+tauk*rk2*(u2*k2(-1))=b(-1)/pi+pg*g+s;
    def=pg*g+s-(tau*(wb*nb)+tau*(wp*np)+tau*(ww*nw)+tauk*rk1*(u1*k1(-1))+tauk*rk2*(u2*k2(-1)));
    g1=zetag*((1+wed1)*p1/pg)^(-nug)*g;
    g2=(1-zetag)*((1+wed2)*p2/pg)^(-nug)*g;
    pg^(1-nug)=zetag*((1+wed1)*p1)^(1-nug)+(1-zetag)*((1+wed2)*p2)^(1-nug);
    log(s/s_bar)=rho_s*log(s(-1)/s_bar)-gamma_sb*(b(-1)-b_bar)/y_bar;
    log(r/r_bar)=delta_r*log(r(-1)/r_bar)+(1-delta_r)*(delta_pi*log(pi/pi_bar)+delta_y*log(gdp/gdp_bar)+delta_g*log(g/g_bar));
    //
    //Capital, utilization, investment
    //
    k1=(1-delta)*k1(-1)+(1-kappa_i1/2*(i1/i1(-1)-1)^2)*i1;
    k2=(1-delta)*k2(-1)+(1-kappa_i2/2*(i2/i2(-1)-1)^2)*i2;
    uc*q1 =beta*uc(+1)*((1-tauk)*(u1(+1)*rk1(+1))- (1+wed1(+1))*p1(+1)*au1(+1) + q1(+1)*(1- delta));
    uc*q2 =beta*uc(+1)*((1-tauk)*(u2(+1)*rk2(+1))- (1+wed2(+1))*p2(+1)*au2(+1) + q2(+1)*(1- delta));
    p1*(1+wed1)=q1*(1-kappa_i1/2*(i1/i1(-1)-1)^2-kappa_i1*(i1/i1(-1)-1)*i1/i1(-1))+beta*(uc(+1)/(uc))*q1(+1)*kappa_i1*(i1(+1)/i1-1)*(i1(+1)/i1)^2;
    p2*(1+wed2)=q2*(1-kappa_i2/2*(i2/i2(-1)-1)^2-kappa_i2*(i2/i2(-1)-1)*i2/i2(-1))+beta*(uc(+1)/(uc))*q2(+1)*kappa_i2*(i2(+1)/i2-1)*(i2(+1)/i2)^2;
    au1=delta1*(u1-1)+delta2/2*(u1-1)^2;
    au2=delta1*(u2-1)+delta2/2*(u2-1)^2;
    (1-tauk)*rk1 = p1*(1+wed1)*(delta1+delta2*(u1-1));
    (1-tauk)*rk2 = p2*(1+wed2)*(delta1+delta2*(u2-1));
    //
    //Firms
    //
    (pi1-1)*pi1=beta*(uc(+1)/uc)*(y1(+1)/y1)*((1+wed1(+1))/(1+wed1))*(pi1(+1)/pi(+1))*(pi1(+1)-1)*pi1(+1)+epsilon1/psi1*(mc1-p1*(epsilon1-1)/epsilon1);
    (pi2-1)*pi2=beta*(uc(+1)/uc)*(y2(+1)/y2)*((1+wed2(+1))/(1+wed2))*(pi2(+1)/pi(+1))*(pi2(+1)-1)*pi2(+1)+epsilon2/psi2*(mc2-p2*(epsilon2-1)/epsilon2);
    y1 = y1_bar*(chi1*(hpbundle1/hpbundle1_bar)^((iota-1)/iota)+(1-chi1)*((aa1/aa1_bar)*(hw1/hw1_bar))^((iota-1)/iota))^(iota/(iota-1));
    y2 = y2_bar*(chi2*(hpbundle2/hpbundle2_bar)^((iota-1)/iota)+(1-chi2)*((aa2/aa2_bar)*(hw2/hw2_bar))^((iota-1)/iota))^(iota/(iota-1));
    hpbundle1=hpbundle1_bar*(alpha1*(kbbundle1/kbbundle1_bar)^((theta-1)/theta)+(1-alpha1)*((aa1/aa1_bar)*(hp1/hp1_bar))^((theta-1)/theta))^(theta/(theta-1));
    hpbundle1=hpbundle2_bar*(alpha2*(kbbundle2/kbbundle2_bar)^((theta-1)/theta)+(1-alpha2)*((aa2/aa2_bar)*(hp2/hp2_bar))^((theta-1)/theta))^(theta/(theta-1));
    kbbundle1=kbbundle1_bar*(gamma1*((u1/u1_bar)*(k1(-1)/k1_bar))^((phi-1)/phi)+(1-gamma1)*((aa1/aa1_bar)*(hb1/hb1_bar))^((phi-1)/phi))^(phi/(phi-1));
    kbbundle2=kbbundle2_bar*(gamma2*((u2/u2_bar)*(k2(-1)/k2_bar))^((phi-1)/phi)+(1-gamma2)*((aa2/aa2_bar)*(hb2/hb2_bar))^((phi-1)/phi))^(phi/(phi-1));
    fw1 = (1-chi1)*(y1_bar/hw1_bar)*(aa1/aa1_bar)^((iota-1)/iota)*(y1/y1_bar)^(1/iota)*(hw1/hw1_bar)^(-1/iota);
    fw2 = (1-chi2)*(y2_bar/hw2_bar)*(aa2/aa2_bar)^((iota-1)/iota)*(y2/y2_bar)^(1/iota)*(hw2/hw2_bar)^(-1/iota);
    fp1 = chi1*(1-alpha1)*(y1_bar/hp1_bar)*(aa1/aa1_bar)^((theta-1)/theta)*(y1/y1_bar)^(1/iota)*(hpbundle1/hpbundle1_bar)^(-1/iota)*(hpbundle1/hpbundle1_bar)^(1/theta)*(hp1/hp1_bar)^(-1/theta);
    fp2 = chi2*(1-alpha2)*(y2_bar/hp2_bar)*(aa2/aa2_bar)^((theta-1)/theta)*(y2/y2_bar)^(1/iota)*(hpbundle2/hpbundle2_bar)^(-1/iota)*(hpbundle2/hpbundle2_bar)^(1/theta)*(hp2/hp2_bar)^(-1/theta);
    fk1 =chi1*alpha1*gamma1*(y1_bar/k1_bar)*(y1/y1_bar)^(1/iota)*(hpbundle1/hpbundle1_bar)^(-1/iota)*(hpbundle1/hpbundle1_bar)^(1/theta)*(kbbundle1/kbbundle1_bar)^(-1/theta)*(kbbundle1/kbbundle1_bar)^(1/phi)*((u1*k1(-1))/(u1_bar*k1_bar))^(-1/phi);
    fk2 =chi2*alpha2*gamma2*(y2_bar/k2_bar)*(y2/y2_bar)^(1/iota)*(hpbundle2/hpbundle2_bar)^(-1/iota)*(hpbundle2/hpbundle2_bar)^(1/theta)*(kbbundle2/kbbundle2_bar)^(-1/theta)*(kbbundle2/kbbundle2_bar)^(1/phi)*((u2*k2(-1))/(u2_bar*k2_bar))^(-1/phi);
    fb1 =chi1*alpha1*(1-gamma1)*(y1_bar/hb1_bar)*(y1/y1_bar)^(1/iota)*(hpbundle1/hpbundle1_bar)^(-1/iota)*(hpbundle1/hpbundle1_bar)^(1/theta)*(kbbundle1/kbbundle1_bar)^(-1/theta)*(kbbundle1/kbbundle1_bar)^(1/phi)*(hb1/hb1_bar)^(-1/phi)*(aa1/aa1_bar)^((phi-1)/phi);
    fb2 =chi2*alpha2*(1-gamma2)*(y2_bar/hb2_bar)*(y2/y2_bar)^(1/iota)*(hpbundle2/hpbundle2_bar)^(-1/iota)*(hpbundle2/hpbundle2_bar)^(1/theta)*(kbbundle2/kbbundle2_bar)^(-1/theta)*(kbbundle2/kbbundle2_bar)^(1/phi)*(hb2/hb2_bar)^(-1/phi)*(aa2/aa2_bar)^((phi-1)/phi);
    mc1*fb1 = wb1 + kappa_b1 * (hb1/hb1(-1)-1)*(1+wed1)*p1*y1/hb1(-1) -kappa_b1 *beta*uc(+1)/(uc)*(hb1(+1)/hb1-1)*(1+wed1(+1))*p1(+1)*y1(+1)*hb1(+1)/(hb1^2);
    mc2*fb2 = wb2 + kappa_b2 * (hb2/hb2(-1)-1)*(1+wed2)*p2*y2/hb2(-1) -kappa_b2 *beta*uc(+1)/(uc)*(hb2(+1)/hb2-1)*(1+wed2(+1))*p2(+1)*y2(+1)*hb2(+1)/(hb2^2);
    mc1*fp1 = wp1 + kappa_p1 * (hp1/hp1(-1)-1)*(1+wed1)*p1*y1/hp1(-1) -kappa_p1 *beta*uc(+1)/(uc)*(hp1(+1)/hp1-1)*(1+wed1(+1))*p1(+1)*y1(+1)*hp1(+1)/(hp1^2);
    mc2*fp2 = wp2 + kappa_p2 * (hp2/hp2(-1)-1)*(1+wed2)*p2*y2/hp2(-1) -kappa_p2 *beta*uc(+1)/(uc)*(hp2(+1)/hp2-1)*(1+wed2(+1))*p2(+1)*y2(+1)*hp2(+1)/(hp2^2);
    mc1*fw1 = ww1 + kappa_w1 * (hw1/hw1(-1)-1)*(1+wed1)*p1*y1/hw1(-1) -kappa_w1 *beta*uc(+1)/(uc)*(hw1(+1)/hw1-1)*(1+wed1(+1))*p1(+1)*y1(+1)*hw1(+1)/(hw1^2);
    mc2*fw2 = ww2 + kappa_w2 * (hw2/hw2(-1)-1)*(1+wed2)*p2*y2/hw2(-1) -kappa_w2 *beta*uc(+1)/(uc)*(hw2(+1)/hw2-1)*(1+wed2(+1))*p2(+1)*y2(+1)*hw2(+1)/(hw2^2);
    mc1*fk1 = rk1;
    mc2*fk2 = rk2;
    //
    //Market clearing
    //
    y1=(1+wed1)*(c1+g1+i1+kappa_b1/2*(hb1/hb1(-1)-1)^2*y1+kappa_p1/2*(hp1/hp1(-1)-1)^2*y1+kappa_w1/2*(hw1/hw1(-1)-1)^2*y1+au1*k1(-1)+psi1/2*(pi1-1)^2*y1)+1/p1*(wedp*hp1*wp1+wedb*hb1*wb1+wedw*hw1*ww1);
    y2=(1+wed2)*(c2+g2+i2+kappa_b2/2*(hb2/hb2(-1)-1)^2*y2+kappa_p2/2*(hp2/hp2(-1)-1)^2*y2+kappa_w2/2*(hw2/hw2(-1)-1)^2*y2+au2*k2(-1)+psi2/2*(pi2-1)^2*y2)+1/p2*(wedp*hp2*wp2+wedb*hb2*wb2+wedw*hw2*ww2);  
    //
    //Shocks
    //
     log(aa1/aa1_bar)=0;
     log(aa2/aa2_bar)=0;
     log(g/g_bar) = rho_g*log(g(-1)/g_bar)+sigma_g*eps_g;
     tau-tau_bar=rho_tau*(tau(-1)-tau_bar)-sigma_tau*eps_tau;
     tauk-tauk_bar=rho_tauk*(tauk(-1)-tauk_bar)-sigma_tauk*eps_tau;
     zetag-zetag_bar=rho_zeta*(zetag(-1)-zetag_bar)+sigma_zeta*eps_g;
     wed1=rho_cov1*wed1(-1)+eps_cov1;
     wed2=rho_cov2*wed2(-1)+eps_cov2;
     wedb=rho_covb*wedb(-1)+eps_covb;
     wedp=rho_covp*wedp(-1)+eps_covp;
     wedw=rho_covw*wedw(-1)+eps_covw;
     //
     //Prices 
     //
     pi1=p1/p1(-1)*pi;
     pi2=p2/p2(-1)*pi;
    //
    //Definitions
    //
    y=p1*y1+p2*y2;
    gdp=p1*gdp1+p2*gdp2;
    gdp1=c1+g1+i1;
    gdp2=c2+g2+i2;
    h_agg=hp+hb+hw;
    h1=hp1+hb1+hw1;
    h2=hp2+hb2+hw2;
    np1=hp1*(1-wedp)/(1+wed1);
    np2=hp2*(1-wedp)/(1+wed2);
    nb1=hb1*(1-wedb)/(1+wed1);
    nb2=hb2*(1-wedb)/(1+wed2);
    nw1=hw1*(1-wedw)/(1+wed1);
    nw2=hw2*(1-wedw)/(1+wed2);
    n1=np1+nb1+nw1;
    n2=np2+nb2+nw2;
    np=np1+np2;
    nb=nb1+nb2;
    nw=nw1+nw2;
    lipp=(1-tau)*np*wp;
    libb=(1-tau)*nb*wb;
    liww=(1-tau)*nw*ww;
    n_agg=n1+n2;
    w_agg=(wp*hp+wb*hb+ww*hw)/h_agg;
    lsp=lipp/(lipp+libb+liww);
    lsb=libb/(lipp+libb+liww);
    lsw=liww/(lipp+libb+liww);
    rr=r/pi(+1);
    u=(k1(-1)*u1+k2(-1)*u2)/(k1(-1)+k2(-1));
    p1wed=p1*(1+wed1);
    p2wed=p2*(1+wed2);
end;

initval;
def=def_bar;
n1=h1_bar;
n2=h2_bar;
n_agg=h_agg_bar;
nw=hw_bar;
np=hp_bar;
nb=hb_bar;
np1=hp1_bar;
np2=hp2_bar;
nb1=hb1_bar;
nb2=hb2_bar;
nw1=hw1_bar;
nw2=hw2_bar;
gdp1=gdp1_bar;
gdp2=gdp2_bar;
wed1=0;
wed2=0;
wedp=0;
wedb=0;
wedw=0;
p1wed=p1_bar;
p2wed=p2_bar;
w_agg=w_agg_bar;
aa1=aa1_bar;
aa2=aa2_bar;
q1=q1_bar;
q2=q2_bar;
k1 = k1_bar;
k2 = k2_bar;
hp = hp_bar;
hp1 = hp1_bar;
hp2 = hp2_bar;
hb = hb_bar;
hb1 = hb1_bar;
hb2 = hb2_bar;
hw = hw_bar;
hw1 = hw1_bar;
hw2 = hw2_bar;
y1 = y1_bar;
y2 = y2_bar;
y = y_bar;
fp1 = fp1_bar;
fp2 = fp2_bar;
fk1 = fk1_bar;
fk2 = fk2_bar;
fb1 = fb1_bar;
fb2 = fb2_bar;
fw1 = fw1_bar;
fw2 = fw2_bar;
r = r_bar;
rr=r_bar;
c1=c1_bar;
c2=c2_bar;
c=c_bar;
i1=i1_bar;
i2=i2_bar;
g1=g1_bar;
g2=g2_bar;
g=g_bar;
wb=wb_bar;
wp=wp_bar;
ww=ww_bar;
wb1=wb1_bar;
wp1=wp1_bar;
ww1=ww1_bar;
wb2=wb2_bar;
wp2=wp2_bar;
ww2=ww2_bar;
b=b_bar;
s=s_bar;
h_agg=h_agg_bar;
u1=u1_bar;
u2=u2_bar;
au2=au2_bar;
au1=au1_bar;
mc1=mc1_bar;
mc2=mc2_bar;
uc=uc_bar;
un_b=un_b_bar;
un_p=un_p_bar;
un_w=un_w_bar;
pi=pi_bar;
pi1=pi1_bar;
pi2=pi2_bar;
p1=p1_bar;
p2=p2_bar;
pg=pg_bar;
lambdaS=lambdaS_bar;
SS=SS_bar;
VV=VV_bar;
hpbundle1=hpbundle1_bar;
hpbundle2=hpbundle2_bar;
kbbundle1=kbbundle1_bar;
kbbundle2=kbbundle2_bar;
h1=h1_bar;
h2=h2_bar;
u=u_bar;
gdp=gdp_bar;
lipp=lip_bar;
liww=liw_bar;
libb=lib_bar;
lsp=lsp_bar;
lsb=lsb_bar;
lsw=lsw_bar;
end;

steady;

shocks;
var eps_g = 0.01^2;
var eps_tau =0.01^2;
var eps_cov1 =(12.3492*0.01)^2; 
var eps_cov2 =(2.1709*0.01)^2;  
var eps_covp =(4.7650*0.01)^2;  
var eps_covb =(12.4780*0.01)^2; 
var eps_covw =(0.1430*0.01)^2;
end;

check(qz_zero_threshold = 1e-12);
stoch_simul(order=1,irf=40,nograph, noprint);

conditional_forecast_paths;
var n1;
periods 1,2,3,4;
values 1.8963,2.0252,2.1164,2.1809;
var n2;
periods 1,2,3,4;
values 1.6833,1.7353,1.7721,1.7982;
var np;
periods 1,2,3,4;
values 1.0365,1.1195,1.1783,1.2198;
var nb;
periods 1,2,3,4;
values 0.83508,0.88335,0.91749,0.94164;
end;
conditional_forecast(parameter_set = calibration, controlled_varexo = (eps_cov1, eps_cov2, eps_covp, eps_covb), replic = 3000);
//plot_conditional_forecast(periods = 16) def n_agg n1 n2 np nb nw y wed1 wed2 wedp wedb wedw;

/*


conditional_forecast_paths;
var n1;
periods 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39;
values 1.8963,2.0252,2.1164,2.1809,2.2265,2.2588,2.2816,2.2978,2.3092,2.3173,2.323,2.327,2.3299,2.3319,2.3333,2.3344,2.3351,2.3356,2.3359,2.3362,2.3364,2.3365,2.3366,2.3366,2.3367,2.3367,2.3367,2.3368,2.3368,2.3368,2.3368,2.3368,2.3368,2.3368,2.3368,2.3368,2.3368,2.3368,2.3368;
var n2;
periods 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39;
values 1.6833,1.7353,1.7721,1.7982,1.8166,1.8296,1.8388,1.8453,1.85,1.8532,1.8555,1.8572,1.8583,1.8591,1.8597,1.8601,1.8604,1.8606,1.8608,1.8609,1.8609,1.861,1.861,1.861,1.8611,1.8611,1.8611,1.8611,1.8611,1.8611,1.8611,1.8611,1.8611,1.8611,1.8611,1.8611,1.8611,1.8611,1.8611;
var np;
periods 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39;
values 1.0365,1.1195,1.1783,1.2198,1.2492,1.27,1.2847,1.2951,1.3024,1.3076,1.3113,1.3139,1.3158,1.3171,1.318,1.3186,1.3191,1.3194,1.3196,1.3198,1.3199,1.32,1.3201,1.3201,1.3201,1.3202,1.3202,1.3202,1.3202,1.3202,1.3202,1.3202,1.3202,1.3202,1.3202,1.3202,1.3202,1.3202,1.3202;
var nb;
periods 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39;
values 0.83508,0.88335,0.91749,0.94164,0.95872,0.9708,0.97935,0.98539,0.98967,0.99269,0.99483,0.99634,0.99741,0.99817,0.99871,0.99908,0.99935,0.99954,0.99968,0.99977,0.99984,0.99989,0.99992,0.99994,0.99996,0.99997,0.99998,0.99999,0.99999,0.99999,0.99999,1,1,1,1,1,1,1,1;
end;


conditional_forecast_paths;
var n1;
periods 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39;
values 1.8285,2.0465,2.1396,2.1461,2.1669,2.1854,2.2019,2.2166,2.2297,2.2414,2.2518,2.2611,2.2693,2.2767,2.2832,2.2891,2.2943,2.2989,2.303,2.3067,2.31,2.3129,2.3155,2.3178,2.3199,2.3217,2.3234,2.3249,2.3262,2.3273,2.3283,2.3293,2.3301,2.3308,2.3315,2.3321,2.3326,2.333,2.3334;
var n2;
periods 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39;
values 1.6531,1.7554,1.7823,1.7636,1.7742,1.7837,1.7921,1.7996,1.8063,1.8123,1.8176,1.8224,1.8266,1.8303,1.8337,1.8367,1.8393,1.8417,1.8438,1.8457,1.8474,1.8489,1.8502,1.8514,1.8525,1.8534,1.8542,1.855,1.8557,1.8562,1.8568,1.8572,1.8577,1.858,1.8584,1.8587,1.8589,1.8592,1.8594;
var np;
periods 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39;
values 0.95395,1.1461,1.21,1.1792,1.1946,1.2083,1.2205,1.2313,1.241,1.2497,1.2573,1.2642,1.2703,1.2757,1.2806,1.2849,1.2888,1.2922,1.2952,1.298,1.3004,1.3025,1.3045,1.3062,1.3077,1.3091,1.3103,1.3114,1.3123,1.3132,1.314,1.3146,1.3152,1.3158,1.3163,1.3167,1.3171,1.3174,1.3177;
var nb;
periods 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39;
values 0.79367,0.89064,0.93371,0.92966,0.93733,0.94416,0.95024,0.95567,0.9605,0.96481,0.96864,0.97206,0.97511,0.97782,0.98024,0.98239,0.98431,0.98602,0.98755,0.9889,0.99011,0.99119,0.99215,0.99301,0.99377,0.99445,0.99505,0.99559,0.99607,0.9965,0.99688,0.99722,0.99753,0.99779,0.99804,0.99825,0.99844,0.99861,0.99876;
end;

conditional_forecast_paths;
var n1;
periods 1,2,3,4;
values 1.8285,2.0465,2.1396,2.1461;
var n2;
periods 1,2,3,4;
values 1.6531,1.7554,1.7823,1.7636;
var np;
periods 1,2,3,4;
values 0.95395,1.1461,1.21,1.1792;
var nb;
periods 1,2,3,4;
values 0.79367,0.89064,0.93371,0.92966;
end;
*/