% Bredemeier, Juessen, and Winkler, 2022.
% This file simulates the effects of fiscal policy measures
  
var gdp1 gdp2 k1 k2 hp hb hw hp1 hb1 hp2 hb2 hw1 hw2 y y1 y2 fp1 fk1 fb1 fw1 fp2 fk2 fb2 fw2 r i1 i2 g g1 g2 c c1 c2 wp wb ww wp1 wp2 wb1 wb2 ww1 ww2 aa1 aa2 b s u1 u2 au1 au2 mc1 mc2 pi pi1 pi2 p1 p2 pg 
uc lambdaS VV SS un_b un_p un_w rk1 rk2 q1 q2 kbbundle1 kbbundle2 hpbundle1 hpbundle2 w_agg h_agg h1 h2 rr u gdp tau tauk wedp wedb wedw wed1 wed2 p1wed p2wed np1 np2 np nb1 nb2 nb nw1 nw2 nw n1 n2 n_agg def zetag lipp liww libb lsp lsb lsw;
varexo eps_g eps_tau;

parameters alpha1 alpha2 gamma1 gamma2 chi1 chi2 phi iota kappa_b1 kappa_p1 kappa_b2 kappa_p2 kappa_w1 kappa_w2 rho_g rho_a rho_s epsilon1 epsilon2 psi1 psi2 delta delta_pi delta_y delta_r delta_g kappa_i1 kappa_i2 xi zeta nu nug gamma_sb eta 
omega_n omega_p omega_w beta sigma theta delta1 delta2 tau_bar tauk_bar hp_int hb_int hw_int lambda kappa_diff kappa_idiff k1_bar k2_bar hp_bar hb_bar hw_bar hp1_bar hb1_bar hw1_bar hp2_bar hb2_bar hw2_bar y_bar y1_bar y2_bar fp1_bar fk1_bar fb1_bar fw1_bar fp2_bar fk2_bar fb2_bar fw2_bar r_bar 
i_bar i1_bar i2_bar def_bar g_bar g1_bar g2_bar c_bar c1_bar c2_bar wp_bar wb_bar ww_bar wp1_bar wb1_bar ww1_bar wp2_bar wb2_bar ww2_bar aa1_bar aa2_bar b_bar s_bar u1_bar u2_bar au1_bar au2_bar mc1_bar mc2_bar pi_bar p1_bar p2_bar pg_bar uc_bar lambdaS_bar VV_bar SS_bar un_b_bar un_p_bar un_w_bar
gdp1_bar gdp2_bar rk1_bar rk2_bar q1_bar q2_bar kbbundle1_bar kbbundle2_bar hpbundle1_bar hpbundle2_bar w_agg_bar h_agg_bar h1_bar h2_bar u_bar gdp_bar rho_tau rho_tauk sigma_tau sigma_tauk zetag_bar sigma_g sigma_zeta rho_zeta
lip_bar liw_bar lib_bar lsp_bar lsb_bar lsw_bar;

sigma_g=sigma_matG(1);
sigma_zeta=sigma_matG(2);
sigma_tau=sigma_tax(1);
sigma_tauk=sigma_tax(2);
iota=1.0001;
phi=2.7;
delta_g=-0.364;                         
kappa_diff=1.8;
hb_int=0.251813422; 
hp_int=0.836349901;
hw_int=0.522369029; 
kappa = 1.85;                          
kappa_b1 = 1/kappa_diff*kappa;         
kappa_p1 = 1/kappa_diff*kappa;
kappa_w1 = 1/kappa_diff*kappa;
kappa_b2 = kappa_diff*kappa;         
kappa_p2 = kappa_diff*kappa;
kappa_w2 = kappa_diff*kappa;
kappa_idiff=1;
kappa_i1 = kappa_idiff*9;
kappa_i2 = 1/kappa_idiff*9;
eta = 1/0.72;                         
epsilon1=6;                            
epsilon2=6;
calvo=2/3;
rho_g = 0.9;
rho_a = 0.9;
rho_s = 0.9;
rho_tau = 0.9;
rho_tauk = 0.9;
rho_zeta = 0.9;
delta = 0.022;
u_bar = 1;
gamma_sb=0.04;
u_elast=3;                             
delta_pi=1.5;
delta_y=0.5/4;
delta_r=0;
sigma=1;
labor_share=0.67;
ww_ratio = 1.5882;  
w_ratio = 0.7723;                
tau_bar=0.28;
tauk_bar=0.36; 
nu= 1.0001;
nug= 1.0001; 
lambda=1;      
beta=0.9927;                              
xi=0.0001;
y_bar = 1;
y1_bar =0.5*y_bar;    
y2_bar=y_bar-y1_bar;  
hb_bar=1;
hp_bar=1.320201126*hb_bar;     
hw_bar=1.877705336*hb_bar;    
hb1_bar=hb_int*hb_bar;
hb2_bar=hb_bar-hb1_bar;
hp1_bar=hp_int*hp_bar;
hp2_bar=hp_bar-hp1_bar;
hw1_bar=hw_int*hw_bar;
hw2_bar=hw_bar-hw1_bar;
h1_bar=hp1_bar+hb1_bar+hw1_bar;
h2_bar=hp2_bar+hb2_bar+hw2_bar;
zetag_bar=0.55;
p1_bar=1;
p2_bar=1;
pi1_bar=1;
pi2_bar=1;
pi_bar=1;
pg_bar=1;
q1_bar=1;
q2_bar=1;
u1_bar=1;
u2_bar=1;
au1_bar=0;
au2_bar=0;
mc1_bar=(epsilon1-1)/epsilon1;
mc2_bar=(epsilon2-1)/epsilon2;
g_bar=0.1961*y_bar; 
g1_bar=zetag_bar*g_bar;
g2_bar=(1-zetag_bar)*g_bar;
b_bar=0.63*4*y_bar;
wb_bar=labor_share*y_bar/(hb_bar+hp_bar*w_ratio+hw_bar*ww_ratio);
wb1_bar=wb_bar;
wb2_bar=wb_bar;
wp_bar=w_ratio*wb_bar;
wp1_bar=wp_bar;
wp2_bar=wp_bar;
ww_bar=ww_ratio*wb_bar;
ww1_bar=ww_bar;
ww2_bar=ww_bar;
labor_share1=wb_bar*(hb1_bar+hp1_bar*w_ratio+hw1_bar*ww_ratio)/y1_bar;
labor_share2=wb_bar*(hb2_bar+hp2_bar*w_ratio+hw2_bar*ww_ratio)/y2_bar;
k1_share=1-(1-mc1_bar)-labor_share1;
k2_share=1-(1-mc2_bar)-labor_share2;
rk1_bar=(1/beta+delta-1)/(1-tauk_bar);
rk2_bar=rk1_bar;
r_bar=1/beta;
k1_bar=k1_share*y1_bar/rk1_bar;
k2_bar=k2_share*y2_bar/rk2_bar;
k_bar=k1_bar+k2_bar;
i1_bar=delta*k1_bar;
i2_bar=delta*k2_bar;
c1_bar=y1_bar-g1_bar-i1_bar;
c2_bar=y2_bar-g2_bar-i2_bar;
zeta=c1_bar/(c1_bar+c2_bar);
c_bar=c1_bar+c2_bar;
i_bar=i1_bar+i2_bar;
fk1_bar = rk1_bar/mc1_bar;
fk2_bar = rk2_bar/mc2_bar;
fb1_bar=wb_bar/mc1_bar;
fb2_bar=wb_bar/mc2_bar;
fp1_bar=wp_bar/mc1_bar;
fp2_bar=wp_bar/mc2_bar;
fw1_bar=ww_bar/mc1_bar;
fw2_bar=ww_bar/mc2_bar;
aa1_bar=1;
aa2_bar=1;
chi1=1-fw1_bar*hw1_bar/y1_bar;
chi2=1-fw2_bar*hw2_bar/y2_bar;
alpha1=1-fp1_bar*hp1_bar/(y1_bar*chi1);
alpha2=1-fp2_bar*hp2_bar/(y2_bar*chi2);
gamma1=fk1_bar*k1_bar/(y1_bar*alpha1*chi1);
gamma2=fk2_bar*k2_bar/(y2_bar*alpha2*chi2);
kbbundle1_bar=1;
kbbundle2_bar=1;
hpbundle1_bar=1;
hpbundle2_bar=1;
s_bar=b_bar/r_bar+tau_bar*wb_bar*hb_bar+tau_bar*wp_bar*hp_bar+tau_bar*ww_bar*hw_bar+tauk_bar*rk1_bar*(u1_bar*k1_bar)+tauk_bar*rk2_bar*(u2_bar*k2_bar)-b_bar/pi_bar-pg_bar*g_bar;
h_agg_bar=hb_bar+hp_bar+hw_bar;
delta1=rk1_bar*(1-tauk_bar);
delta2=1/u_elast*delta1; 
calvo_mc=(1-calvo)*(1-beta*calvo)/calvo;
psi1=(epsilon1-1)/calvo_mc;
psi2=psi1;
%JR preferences;
SS_bar=c_bar;
xin=wb_bar*(1-tau_bar)/(hb_bar^eta*c_bar);
xip=wp_bar*(1-tau_bar)/(hp_bar^eta*c_bar);
xiw=ww_bar*(1-tau_bar)/(hw_bar^eta*c_bar);
omega_n=xin/(1+xi/(1-beta*(1-xi))*(xin/(1+eta)*hb_bar^(1+eta)+xip/(1+eta)*hp_bar^(1+eta)+xiw/(1+eta)*hw_bar^(1+eta)));
omega_p=omega_n*xip/xin;
omega_w=omega_n*xiw/xin;
VV_bar=(c_bar-(omega_n/(1+eta)*hb_bar^(1+eta)+omega_p/(1+eta)*hp_bar^(1+eta)+omega_w/(1+eta)*hw_bar^(1+eta))*SS_bar)^(-sigma);
lambdaS_bar=-VV_bar*(omega_n/(1+eta)*hb_bar^(1+eta)+omega_p/(1+eta)*hp_bar^(1+eta)+omega_w/(1+eta)*hw_bar^(1+eta))/(1-beta*(1-xi));
uc_bar=VV_bar+xi*lambdaS_bar;
un_b_bar=omega_n*hb_bar^eta*VV_bar*SS_bar;
un_p_bar=omega_p*hp_bar^eta*VV_bar*SS_bar;
un_w_bar=omega_w*hw_bar^eta*VV_bar*SS_bar;
w_agg_bar=(wp_bar*hp_bar+wb_bar*hb_bar+ww_bar*hw_bar)/h_agg_bar;
u_bar=(k1_bar*u1_bar+k2_bar*u2_bar)/(k1_bar+k2_bar);
gdp_bar=c_bar+pg_bar*g_bar+p1_bar*i1_bar+p2_bar*i2_bar;
gdp1_bar=c1_bar+i1_bar+g1_bar;
gdp2_bar=c2_bar+i2_bar+g2_bar;
def_bar=b_bar*(1/r_bar-1/pi_bar);
lip_bar=hp_bar*wp_bar*(1-tau_bar);
liw_bar=hw_bar*ww_bar*(1-tau_bar);
lib_bar=hb_bar*wb_bar*(1-tau_bar);
lsp_bar=lip_bar/(lip_bar+lib_bar+liw_bar);
lsb_bar=lib_bar/(lip_bar+lib_bar+liw_bar);
lsw_bar=liw_bar/(lip_bar+lib_bar+liw_bar);
theta=0.07;
%theta=(1-hb_bar/h_agg_bar*phi-hw_bar/h_agg_bar*iota)*h_agg_bar/hp_bar;

model;
    //
    //Household
    //
    VV=(c-(omega_n/(1+eta)*hb^(1+eta)+omega_p/(1+eta)*hp^(1+eta)+omega_w/(1+eta)*hw^(1+eta))*SS)^(-sigma);
    SS=c^xi*SS(-1)^(1-xi);
    uc=VV+xi*lambdaS*SS/c;
    lambdaS=-VV*(omega_n/(1+eta)*hb^(1+eta)+omega_p/(1+eta)*hp^(1+eta)+omega_w/(1+eta)*hw^(1+eta))+beta*(1-xi)*lambdaS(+1)*SS(+1)/SS;
    un_b=omega_n*hb^eta*VV*SS;
    un_p=omega_p*hp^eta*VV*SS;
    un_w=omega_w*hw^eta*VV*SS;
    wb*(1-tau)=un_b/uc;
    wp*(1-tau)=un_p/uc;
    ww*(1-tau)=un_w/uc;
    uc=beta*uc(+1)*r/pi(+1);
    c1=zeta*((1+wed1)*p1)^(-nu)*c;
    c2=(1-zeta)*((1+wed2)*p2)^(-nu)*c;
    1=zeta*((1+wed1)*p1)^(1-nu)+(1-zeta)*((1+wed2)*p2)^(1-nu);
    hp1=hp_int*((1-wedp)*wp1/wp)^lambda*hp;
    hp2=(1-hp_int)*((1-wedp)*wp2/wp)^lambda*hp;
    hb1=hb_int*((1-wedb)*wb1/wb)^lambda*hb;
    hb2=(1-hb_int)*((1-wedb)*wb2/wb)^lambda*hb;
    hw1=hw_int*((1-wedw)*ww1/ww)^lambda*hw;
    hw2=(1-hw_int)*((1-wedw)*ww2/ww)^lambda*hw;
    wp^(1+lambda)=hp_int*((1-wedp)*wp1)^(1+lambda)+(1-hp_int)*((1-wedp)*wp2)^(1+lambda);
    wb^(1+lambda)=hb_int*((1-wedb)*wb1)^(1+lambda)+(1-hb_int)*((1-wedb)*wb2)^(1+lambda);
    ww^(1+lambda)=hw_int*((1-wedw)*ww1)^(1+lambda)+(1-hw_int)*((1-wedw)*ww2)^(1+lambda);
    //
    //Fiscal and monetary policy
    //
    b/r+tau*wb*hb+tau*wp*hp+tau*ww*hw+tauk*rk1*(u1*k1(-1))+tauk*rk2*(u2*k2(-1))=b(-1)/pi+pg*g+s;
    def=pg*g+s-(tau*(wb*nb)+tau*(wp*np)+tau*(ww*nw)+tauk*rk1*(u1*k1(-1))+tauk*rk2*(u2*k2(-1)));
    g1=zetag*((1+wed1)*p1/pg)^(-nug)*g;
    g2=(1-zetag)*((1+wed2)*p2/pg)^(-nug)*g;
    pg^(1-nug)=zetag*((1+wed1)*p1)^(1-nug)+(1-zetag)*((1+wed2)*p2)^(1-nug);
    log(s/s_bar)=rho_s*log(s(-1)/s_bar)-gamma_sb*(b(-1)-b_bar)/y_bar;
    log(r/r_bar)=delta_r*log(r(-1)/r_bar)+(1-delta_r)*(delta_pi*log(pi/pi_bar)+delta_y*log(gdp/gdp_bar)+delta_g*log(g/g_bar));
    //
    //Capital, utilization, investment
    //
    k1=(1-delta)*k1(-1)+(1-kappa_i1/2*(i1/i1(-1)-1)^2)*i1;
    k2=(1-delta)*k2(-1)+(1-kappa_i2/2*(i2/i2(-1)-1)^2)*i2;
    uc*q1 =beta*uc(+1)*((1-tauk)*(u1(+1)*rk1(+1))- (1+wed1(+1))*p1(+1)*au1(+1) + q1(+1)*(1- delta));
    uc*q2 =beta*uc(+1)*((1-tauk)*(u2(+1)*rk2(+1))- (1+wed2(+1))*p2(+1)*au2(+1) + q2(+1)*(1- delta));
    p1*(1+wed1)=q1*(1-kappa_i1/2*(i1/i1(-1)-1)^2-kappa_i1*(i1/i1(-1)-1)*i1/i1(-1))+beta*(uc(+1)/(uc))*q1(+1)*kappa_i1*(i1(+1)/i1-1)*(i1(+1)/i1)^2;
    p2*(1+wed2)=q2*(1-kappa_i2/2*(i2/i2(-1)-1)^2-kappa_i2*(i2/i2(-1)-1)*i2/i2(-1))+beta*(uc(+1)/(uc))*q2(+1)*kappa_i2*(i2(+1)/i2-1)*(i2(+1)/i2)^2;
    au1=delta1*(u1-1)+delta2/2*(u1-1)^2;
    au2=delta1*(u2-1)+delta2/2*(u2-1)^2;
    (1-tauk)*rk1 = p1*(1+wed1)*(delta1+delta2*(u1-1));
    (1-tauk)*rk2 = p2*(1+wed2)*(delta1+delta2*(u2-1));
    //
    //Firms
    //
    (pi1-1)*pi1=beta*(uc(+1)/uc)*(y1(+1)/y1)*((1+wed1(+1))/(1+wed1))*(pi1(+1)/pi(+1))*(pi1(+1)-1)*pi1(+1)+epsilon1/psi1*(mc1-p1*(epsilon1-1)/epsilon1);
    (pi2-1)*pi2=beta*(uc(+1)/uc)*(y2(+1)/y2)*((1+wed2(+1))/(1+wed2))*(pi2(+1)/pi(+1))*(pi2(+1)-1)*pi2(+1)+epsilon2/psi2*(mc2-p2*(epsilon2-1)/epsilon2);
    y1 = y1_bar*(chi1*(hpbundle1/hpbundle1_bar)^((iota-1)/iota)+(1-chi1)*((aa1/aa1_bar)*(hw1/hw1_bar))^((iota-1)/iota))^(iota/(iota-1));
    y2 = y2_bar*(chi2*(hpbundle2/hpbundle2_bar)^((iota-1)/iota)+(1-chi2)*((aa2/aa2_bar)*(hw2/hw2_bar))^((iota-1)/iota))^(iota/(iota-1));
    hpbundle1=hpbundle1_bar*(alpha1*(kbbundle1/kbbundle1_bar)^((theta-1)/theta)+(1-alpha1)*((aa1/aa1_bar)*(hp1/hp1_bar))^((theta-1)/theta))^(theta/(theta-1));
    hpbundle1=hpbundle2_bar*(alpha2*(kbbundle2/kbbundle2_bar)^((theta-1)/theta)+(1-alpha2)*((aa2/aa2_bar)*(hp2/hp2_bar))^((theta-1)/theta))^(theta/(theta-1));
    kbbundle1=kbbundle1_bar*(gamma1*((u1/u1_bar)*(k1(-1)/k1_bar))^((phi-1)/phi)+(1-gamma1)*((aa1/aa1_bar)*(hb1/hb1_bar))^((phi-1)/phi))^(phi/(phi-1));
    kbbundle2=kbbundle2_bar*(gamma2*((u2/u2_bar)*(k2(-1)/k2_bar))^((phi-1)/phi)+(1-gamma2)*((aa2/aa2_bar)*(hb2/hb2_bar))^((phi-1)/phi))^(phi/(phi-1));
    fw1 = (1-chi1)*(y1_bar/hw1_bar)*(aa1/aa1_bar)^((iota-1)/iota)*(y1/y1_bar)^(1/iota)*(hw1/hw1_bar)^(-1/iota);
    fw2 = (1-chi2)*(y2_bar/hw2_bar)*(aa2/aa2_bar)^((iota-1)/iota)*(y2/y2_bar)^(1/iota)*(hw2/hw2_bar)^(-1/iota);
    fp1 = chi1*(1-alpha1)*(y1_bar/hp1_bar)*(aa1/aa1_bar)^((theta-1)/theta)*(y1/y1_bar)^(1/iota)*(hpbundle1/hpbundle1_bar)^(-1/iota)*(hpbundle1/hpbundle1_bar)^(1/theta)*(hp1/hp1_bar)^(-1/theta);
    fp2 = chi2*(1-alpha2)*(y2_bar/hp2_bar)*(aa2/aa2_bar)^((theta-1)/theta)*(y2/y2_bar)^(1/iota)*(hpbundle2/hpbundle2_bar)^(-1/iota)*(hpbundle2/hpbundle2_bar)^(1/theta)*(hp2/hp2_bar)^(-1/theta);
    fk1 =chi1*alpha1*gamma1*(y1_bar/k1_bar)*(y1/y1_bar)^(1/iota)*(hpbundle1/hpbundle1_bar)^(-1/iota)*(hpbundle1/hpbundle1_bar)^(1/theta)*(kbbundle1/kbbundle1_bar)^(-1/theta)*(kbbundle1/kbbundle1_bar)^(1/phi)*((u1*k1(-1))/(u1_bar*k1_bar))^(-1/phi);
    fk2 =chi2*alpha2*gamma2*(y2_bar/k2_bar)*(y2/y2_bar)^(1/iota)*(hpbundle2/hpbundle2_bar)^(-1/iota)*(hpbundle2/hpbundle2_bar)^(1/theta)*(kbbundle2/kbbundle2_bar)^(-1/theta)*(kbbundle2/kbbundle2_bar)^(1/phi)*((u2*k2(-1))/(u2_bar*k2_bar))^(-1/phi);
    fb1 =chi1*alpha1*(1-gamma1)*(y1_bar/hb1_bar)*(y1/y1_bar)^(1/iota)*(hpbundle1/hpbundle1_bar)^(-1/iota)*(hpbundle1/hpbundle1_bar)^(1/theta)*(kbbundle1/kbbundle1_bar)^(-1/theta)*(kbbundle1/kbbundle1_bar)^(1/phi)*(hb1/hb1_bar)^(-1/phi)*(aa1/aa1_bar)^((phi-1)/phi);
    fb2 =chi2*alpha2*(1-gamma2)*(y2_bar/hb2_bar)*(y2/y2_bar)^(1/iota)*(hpbundle2/hpbundle2_bar)^(-1/iota)*(hpbundle2/hpbundle2_bar)^(1/theta)*(kbbundle2/kbbundle2_bar)^(-1/theta)*(kbbundle2/kbbundle2_bar)^(1/phi)*(hb2/hb2_bar)^(-1/phi)*(aa2/aa2_bar)^((phi-1)/phi);
    mc1*fb1 = wb1 + kappa_b1 * (hb1/hb1(-1)-1)*(1+wed1)*p1*y1/hb1(-1) -kappa_b1 *beta*uc(+1)/(uc)*(hb1(+1)/hb1-1)*(1+wed1(+1))*p1(+1)*y1(+1)*hb1(+1)/(hb1^2);
    mc2*fb2 = wb2 + kappa_b2 * (hb2/hb2(-1)-1)*(1+wed2)*p2*y2/hb2(-1) -kappa_b2 *beta*uc(+1)/(uc)*(hb2(+1)/hb2-1)*(1+wed2(+1))*p2(+1)*y2(+1)*hb2(+1)/(hb2^2);
    mc1*fp1 = wp1 + kappa_p1 * (hp1/hp1(-1)-1)*(1+wed1)*p1*y1/hp1(-1) -kappa_p1 *beta*uc(+1)/(uc)*(hp1(+1)/hp1-1)*(1+wed1(+1))*p1(+1)*y1(+1)*hp1(+1)/(hp1^2);
    mc2*fp2 = wp2 + kappa_p2 * (hp2/hp2(-1)-1)*(1+wed2)*p2*y2/hp2(-1) -kappa_p2 *beta*uc(+1)/(uc)*(hp2(+1)/hp2-1)*(1+wed2(+1))*p2(+1)*y2(+1)*hp2(+1)/(hp2^2);
    mc1*fw1 = ww1 + kappa_w1 * (hw1/hw1(-1)-1)*(1+wed1)*p1*y1/hw1(-1) -kappa_w1 *beta*uc(+1)/(uc)*(hw1(+1)/hw1-1)*(1+wed1(+1))*p1(+1)*y1(+1)*hw1(+1)/(hw1^2);
    mc2*fw2 = ww2 + kappa_w2 * (hw2/hw2(-1)-1)*(1+wed2)*p2*y2/hw2(-1) -kappa_w2 *beta*uc(+1)/(uc)*(hw2(+1)/hw2-1)*(1+wed2(+1))*p2(+1)*y2(+1)*hw2(+1)/(hw2^2);
    mc1*fk1 = rk1;
    mc2*fk2 = rk2;
    //
    //Market clearing
    //
    y1=(1+wed1)*(c1+g1+i1+kappa_b1/2*(hb1/hb1(-1)-1)^2*y1+kappa_p1/2*(hp1/hp1(-1)-1)^2*y1+kappa_w1/2*(hw1/hw1(-1)-1)^2*y1+au1*k1(-1)+psi1/2*(pi1-1)^2*y1)+1/p1*(wedp*hp1*wp1+wedb*hb1*wb1+wedw*hw1*ww1);
    y2=(1+wed2)*(c2+g2+i2+kappa_b2/2*(hb2/hb2(-1)-1)^2*y2+kappa_p2/2*(hp2/hp2(-1)-1)^2*y2+kappa_w2/2*(hw2/hw2(-1)-1)^2*y2+au2*k2(-1)+psi2/2*(pi2-1)^2*y2)+1/p2*(wedp*hp2*wp2+wedb*hb2*wb2+wedw*hw2*ww2);  
    //
    //Shocks
    //
     log(aa1/aa1_bar)=0;
     log(aa2/aa2_bar)=0;
     log(g/g_bar) = rho_g*log(g(-1)/g_bar)+sigma_g*eps_g;
     tau-tau_bar=rho_tau*(tau(-1)-tau_bar)-sigma_tau*eps_tau;
     tauk-tauk_bar=rho_tauk*(tauk(-1)-tauk_bar)-sigma_tauk*eps_tau;
     zetag-zetag_bar=rho_zeta*(zetag(-1)-zetag_bar)+sigma_zeta*eps_g;
     wed1=0;
     wed2=0;
     wedb=0;
     wedp=0;
     wedw=0;
     //
     //Prices 
     //
     pi1=p1/p1(-1)*pi;
     pi2=p2/p2(-1)*pi;
    //
    //Definitions
    //
    y=p1*y1+p2*y2;
    gdp=p1*gdp1+p2*gdp2;
    gdp1=c1+g1+i1;
    gdp2=c2+g2+i2;
    h_agg=hp+hb+hw;
    h1=hp1+hb1+hw1;
    h2=hp2+hb2+hw2;
    np1=hp1*(1-wedp)/(1+wed1);
    np2=hp2*(1-wedp)/(1+wed2);
    nb1=hb1*(1-wedb)/(1+wed1);
    nb2=hb2*(1-wedb)/(1+wed2);
    nw1=hw1*(1-wedw)/(1+wed1);
    nw2=hw2*(1-wedw)/(1+wed2);
    n1=np1+nb1+nw1;
    n2=np2+nb2+nw2;
    np=np1+np2;
    nb=nb1+nb2;
    nw=nw1+nw2;
    lipp=(1-tau)*np*wp;
    libb=(1-tau)*nb*wb;
    liww=(1-tau)*nw*ww;
    lsp=lipp/(lipp+libb+liww);
    lsb=libb/(lipp+libb+liww);
    lsw=liww/(lipp+libb+liww);
    n_agg=n1+n2;
    w_agg=(wp*hp+wb*hb+ww*hw)/h_agg;
    rr=r/pi(+1);
    u=(k1(-1)*u1+k2(-1)*u2)/(k1(-1)+k2(-1));
    p1wed=p1*(1+wed1);
    p2wed=p2*(1+wed2);
end;

initval;
def=def_bar;
n1=h1_bar;
n2=h2_bar;
n_agg=h_agg_bar;
nw=hw_bar;
np=hp_bar;
nb=hb_bar;
np1=hp1_bar;
np2=hp2_bar;
nb1=hb1_bar;
nb2=hb2_bar;
nw1=hw1_bar;
nw2=hw2_bar;
gdp1=gdp1_bar;
gdp2=gdp2_bar;
wed1=0;
wed2=0;
wedp=0;
wedb=0;
wedw=0;
p1wed=p1_bar;
p2wed=p2_bar;
w_agg=w_agg_bar;
aa1=aa1_bar;
aa2=aa2_bar;
q1=q1_bar;
q2=q2_bar;
k1 = k1_bar;
k2 = k2_bar;
hp = hp_bar;
hp1 = hp1_bar;
hp2 = hp2_bar;
hb = hb_bar;
hb1 = hb1_bar;
hb2 = hb2_bar;
hw = hw_bar;
hw1 = hw1_bar;
hw2 = hw2_bar;
y1 = y1_bar;
y2 = y2_bar;
y = y_bar;
fp1 = fp1_bar;
fp2 = fp2_bar;
fk1 = fk1_bar;
fk2 = fk2_bar;
fb1 = fb1_bar;
fb2 = fb2_bar;
fw1 = fw1_bar;
fw2 = fw2_bar;
r = r_bar;
rr=r_bar;
c1=c1_bar;
c2=c2_bar;
c=c_bar;
i1=i1_bar;
i2=i2_bar;
g1=g1_bar;
g2=g2_bar;
g=g_bar;
wb=wb_bar;
wp=wp_bar;
ww=ww_bar;
wb1=wb1_bar;
wp1=wp1_bar;
ww1=ww1_bar;
wb2=wb2_bar;
wp2=wp2_bar;
ww2=ww2_bar;
b=b_bar;
s=s_bar;
h_agg=h_agg_bar;
u1=u1_bar;
u2=u2_bar;
au2=au2_bar;
au1=au1_bar;
mc1=mc1_bar;
mc2=mc2_bar;
uc=uc_bar;
un_b=un_b_bar;
un_p=un_p_bar;
un_w=un_w_bar;
pi=pi_bar;
pi1=pi1_bar;
pi2=pi2_bar;
p1=p1_bar;
p2=p2_bar;
pg=pg_bar;
lambdaS=lambdaS_bar;
SS=SS_bar;
VV=VV_bar;
hpbundle1=hpbundle1_bar;
hpbundle2=hpbundle2_bar;
kbbundle1=kbbundle1_bar;
kbbundle2=kbbundle2_bar;
h1=h1_bar;
h2=h2_bar;
u=u_bar;
gdp=gdp_bar;
lipp=lip_bar;
liww=liw_bar;
libb=lib_bar;
lsp=lsp_bar;
lsb=lsb_bar;
lsw=lsw_bar;
end;

shocks;
var eps_g = 0.01^2;
var eps_tau =0.01^2;
end;

steady;
check(qz_zero_threshold = 1e-12);
stoch_simul(order=1,irf=40,nograph,noprint);